
static ARRAY RegisterDB;


HANDLE RegLock;
UINT4 kRegIrql = 0;



int RegistrationMgrInitialize(void)
{

	CreateMutex(&RegLock, TRUE, NULL);
	

	if (ArrayInitialize(&RegisterDB, 
				        INITIAL_NO_OF_MODULES, 
						GROW_SIZE, 
						sizeof(MODULECONTEXT)) != _SUCCESS)
	{
		return (0);
	}
	return (1);
}

int RegisterModule(ULONG ui32ThreadId, 
		                      UCHAR ui8aToken[MAX_TOKEN_BUFF])
{

	if (WaitForSingleObject(&RegLock, 0, &kRegIrql) != _SUCCESS)
	{
		return 0;      
	}

	// Some code
	//
	
	ReleaseMutex(&RegLock, &kRegIrql);

	return 1;
}
