

PVOID Malloc(size_t Size)
{
	return (malloc(Size));
}

VOID MemCpy(PVOID pDest, const PVOID pSrc, size_t Size)
{
	memcpy(pDest, pSrc, Size);

}

VOID Free(PVOID p)
{
	free(p);

}

VOID Memset(PVOID pDest, INT c, size_t count)
{
	memset(pDest, c, count);
}

VOID StringCopy(PCHAR pcDest, PCHAR pcSrc)
{
	strcpy(pcDest, pcSrc);
}

size_t MemCmp(PVOID pSrc1, PVOID pSrc2, size_t Length)
{
	return (memcmp(pSrc1, pSrc2, Length));

}

VOID CreateMutex(PVOID pObject, 
					  BOOL bInitialOwner, 
					  PCHAR lpszName)
{
		pthread_mutexattr_t mutexattr;
        memset(&mutexattr,0,sizeof(mutexattr));
        pthread_mutex_t *pmutex;

        
        pthread_mutexattr_settype(&mutexattr, PTHREAD_MUTEX_RECURSIVE);
        pmutex = new pthread_mutex_t();
        
        pthread_mutex_init(pmutex,
                           &mutexattr);

        
        pthread_mutexattr_destroy(&mutexattr);  

}

int WaitForSingleObject(PVOID pObject, 
										ULONG TimeOut,
										PVOID pIrql)
{
	
	  int i = pthread_mutex_trylock((pthread_mutex_t *) pObject);
	  if (i == 0)
	  		return 1;		 	
	  else
	        return 0;	
}

int ReleaseMutex(PVOID pObject, PVOID pIrql)
{
	int iRet = pthread_mutex_unlock((pthread_mutex_t *) pObject);
	if (iRet == 0)
	{
	  return (1);
	}
	else
		return (0);
}

